<?php
/**
 *
 */
class AssetsManager extends CAssetManager
{
    private $_published;

    public function publish($path, $hashByName = false, $level = -1, $forceCopy = false)
    {
        if (isset($this->_published[$path]))
            return $this->_published[$path];
        else if (($src = realpath($path)) !== false) {
            $appPath = realpath(Yii::getPathOfAlias('site'));
            if (is_file($src)) {
                $dir = $this->hash($hashByName ? str_replace($appPath, '', $src) : dirname($src) . filemtime($src));
                $fileName = basename($src);
                $dstDir = $this->getBasePath() . DIRECTORY_SEPARATOR . $dir;
                $dstFile = $dstDir . DIRECTORY_SEPARATOR . $fileName;

                if ($this->linkAssets) {
                    if (!is_file($dstFile)) {
                        if (!is_dir($dstDir)) {
                            mkdir($dstDir);
                            @chmod($dstDir, $this->newDirMode);
                        }
                        symlink($src, $dstFile);
                    }
                } else if (@filemtime($dstFile) < @filemtime($src)) {
                    if (!is_dir($dstDir)) {
                        mkdir($dstDir);
                        @chmod($dstDir, $this->newDirMode);
                    }
                    copy($src, $dstFile);
                    @chmod($dstFile, $this->newFileMode);
                }

                return $this->_published[$path] = $this->getBaseUrl() . "/$dir/$fileName";
            } else if (is_dir($src)) {
                $dir = $this->hash($hashByName ? str_replace($appPath, '', $src) : $src . filemtime($src));
                $dstDir = $this->getBasePath() . DIRECTORY_SEPARATOR . $dir;

                if ($this->linkAssets) {
                    if (!is_dir($dstDir))
                        symlink($src, $dstDir);
                } else if (!is_dir($dstDir) || $forceCopy) {
                    CFileHelper::copyDirectory($src, $dstDir, array(
                        'exclude' => $this->excludeFiles,
                        'level' => $level,
                        'newDirMode' => $this->newDirMode,
                        'newFileMode' => $this->newFileMode,
                    ));
                }

                return $this->_published[$path] = $this->getBaseUrl() . '/' . $dir;
            }
        }
        throw new CException(Yii::t('yii', 'The asset "{asset}" to be published does not exist.',
            array('{asset}' => $path)));
    }
}
