<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 */

$postUrl = $trackerBaseUrl . '/v1/pageviews';

// Build the attributes string.
$attributesStr = '';
$first = true;
foreach ($attributes as $name => $value) {
    if (!$first) {
        $currAttr = ', ';
    } else {
        $currAttr = '';
        $first = false;
    }
    $currAttr .= '\'' . str_replace('\'', '\\\'', $name) . '\': ' . strval($value);
    $attributesStr .= $currAttr;
}

// Build the categories string.
$categoriesStr = '';
if(!empty($categories)) {
    $first = true;
    foreach ($categories as $category) {
        if (!$first) {
            $categoriesStr .= ', ';
        } else {
            $first = false;
        }
        $categoriesStr .= '\'' . str_replace('\'', '\\\'', $category) . '\'';
    }
}
?>
<script>
    (function() {
        var url = '<?php echo $postUrl ?>';
        var pageView = {
            pageId: '<?php echo $pageId ?>',
            user: '<?php echo $userId ?>',
            attributes: { <?php echo $attributesStr ?> }<?php if (!empty($categoriesStr)): ?>,
            categories: [ <?php echo $categoriesStr ?> ]
            <?php endif; ?>
        };
        $.post(url, JSON.stringify(pageView), function(data) {}).fail(function(jqXHR, textStatus) {
            console.error('Marketing Automation Tracking request failed with status code ' + jqXHR.status + '. Message: ' + textStatus);
        });
    })();
</script>