<?php
    /**
     * Gentics Portal.Node PHP
     * Author & Copyright (c) by Gentics Software GmbH
     * sales@gentics.com
     * http://www.gentics.com
     * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
     * You must not use this software without a valid license agreement.
     *
     */
?>

<?php
        foreach ($contentList as $resultItem) {
            $resultItem['attributes']['updatetimestamp'] = !empty($resultItem['attributes']['updatetimestamp']) ? $resultItem['attributes']['updatetimestamp'] : 0;

            foreach ($resultItem['attributes'] as $attributekey => $attributevalue ) {
                if ( isset( $attributevalue ) && $attributevalue != '' ) $replace_array1['{{'.$attributekey.'}}'] = $attributevalue;
                else $replace_array1['{{'.$attributekey.'}}'] = 'empty';
            }
            $replace_array2 = array(
                '{{name}}' => !empty($resultItem['attributes']['name']) ? $resultItem['attributes']['name'] : '',
                '{{url}}' => Yii::app()->CreateUrl($resultItem['attributes']['url']),
                '{{content}}' => !empty($resultItem['attributes']['content']) ? $resultItem['attributes']['content'] : '',
                '{{datetime}}' => Yii::app()->dateFormatter->formatDateTime($resultItem['attributes']['updatetimestamp'], 'medium', 'medium'),
                '{{date}}' => Yii::app()->dateFormatter->formatDateTime($resultItem['attributes']['updatetimestamp'], 'medium', null),
                '{{time}}' => Yii::app()->dateFormatter->formatDateTime($resultItem['attributes']['updatetimestamp'], null, 'medium'),
            );
            $replace_array = array_merge($replace_array1,$replace_array2);
            $content = PersonalizedContentModule::t($this->tplString, $replace_array);
            //The following expression would remove not replaced parameters
            $content = preg_replace('/{{\w+}}/','',$content);
            echo $content;
            unset($replace_array1, $replace_array2, $resultItem, $replace_array, $content);
        }

        if ($this->totalQty > $this->perPage) {
            $isArrows = Yii::app()->getModule('personalizedContent')->enableArrowsInPaging;
            $pages = array();
            $p = ceil($this->offset / $this->perPage);
            $pagesQty = ceil($this->totalQty / $this->perPage);

            if($p > 0){
                $pages[] = '<a href="'.rtrim($this->baseHref, '&?').'">'.PersonalizedContentModule::t('First').'</a>';

                if($p==1){
                    $pages[] = '<a href="'.rtrim($this->baseHref, '&?').'">'.($isArrows?"<<":PersonalizedContentModule::t('Previous')).'</a>&nbsp;&nbsp;';
                }else{
                    $pages[] = '<a href="'.$this->baseHref.'offset='.(($p-1)*$this->perPage).'">'.($isArrows?"<<":PersonalizedContentModule::t('Previous')).'</a>&nbsp;&nbsp;';
                }
            }
            for($i=0; $i < $pagesQty; $i++){
                if($i == $p){
                    $pages[] = '<span class="current">'.($i+1).'</span>';
                } else if($i>($p-5) && $i < ($p+5)){
                    $pages[] = '<a href="'.$this->baseHref.'offset='.($i*$this->perPage).'">'.($i+1).'</a>';
                }
            }
            if($p < ($pagesQty-1) ){
                $pages[] = '&nbsp;&nbsp;<a href="'.$this->baseHref.'offset='.(($p+1)*$this->perPage).'">'.($isArrows?">>":PersonalizedContentModule::t('Next')).'</a>';

                $pages[] = '<a href="'.$this->baseHref.'offset='.(($pagesQty-1)*$this->perPage).'">'.PersonalizedContentModule::t('Last').'</a>';
            }

            $pages = implode(' | ', $pages);
            
            echo '<div class="search-result-pagination">&nbsp;'.$pages.'&nbsp;</div>';
        }
?>