<?php

/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 * Last remembered widget - displays last N remembered pages
 *
 **/
class LastRemembered extends BaseWidget
{
    /**
     * Collection id for filtering pages
     *
     * @var string
     **/
    public $collection_id;

    /**
     * Amount of displaying items
     *
     * @var string
     **/
    public $count = 4;

    /**
     * Find pages, display
     *
     **/
    public function run()
    {
        if($this->collection_id === null){
            $this->collection_id = Yii::app()->getModule('remember')->getUserCollectionId();
        }
        $criteria = new CDbCriteria();
        $criteria->compare('collection_id', $this->collection_id);
        $criteria->order = 'created DESC';
        $criteria->limit = $this->count;
        
        $pages = RememberedPage::model()->findAll($criteria);
	    if(count($pages)){
            $this->render('LastRemembered', array('pages'=>$pages));
        }
    }    
}
